VERSION 4.00
Begin VB.Form frmDirTree 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Folders"
   ClientHeight    =   4590
   ClientLeft      =   1155
   ClientTop       =   1455
   ClientWidth     =   3525
   ControlBox      =   0   'False
   Height          =   4995
   Left            =   1095
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4590
   ScaleWidth      =   3525
   Top             =   1110
   Width           =   3645
   Begin VB.PictureBox picIcon 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   235
      Left            =   360
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   4
      Top             =   4080
      Visible         =   0   'False
      Width           =   235
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   2280
      TabIndex        =   3
      Top             =   4080
      Width           =   975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1200
      TabIndex        =   2
      Top             =   4080
      Width           =   975
   End
   Begin VB.Label lblPath 
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   0
      Width           =   3015
   End
   Begin ComctlLib.ImageList imgDirTree 
      Left            =   3000
      Top             =   120
      _Version        =   65536
      _ExtentX        =   1005
      _ExtentY        =   1005
      _StockProps     =   1
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16777215
      NumImages       =   8
      i1              =   "DirTree.frx":0000
      i2              =   "DirTree.frx":01BB
      i3              =   "DirTree.frx":0376
      i4              =   "DirTree.frx":0531
      i5              =   "DirTree.frx":06EC
      i6              =   "DirTree.frx":08A7
      i7              =   "DirTree.frx":0A62
      i8              =   "DirTree.frx":0C19
   End
   Begin ComctlLib.TreeView tvwDirTree 
      Height          =   3375
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   3015
      _Version        =   65536
      _ExtentX        =   5318
      _ExtentY        =   5953
      _StockProps     =   196
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Appearance      =   1
      ImageList       =   ""
      Indentation     =   353
      LabelEdit       =   1
      PathSeparator   =   "\"
      Style           =   7
   End
End
Attribute VB_Name = "frmDirTree"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Dim sMainDrives() As String

Private Sub cmdCancel_Click()
Unload Me
End Sub

Private Sub cmdOK_Click()
If lblPath <> "" Then
    If Left$(lblPath, 2) = vbCrLf Then
        MsgBox Right$(lblPath, Len(lblPath) - 2), 64, App.Title
    Else
        MsgBox lblPath, 64, App.Title
    End If
End If
End Sub


Private Sub Form_Load()
Dim k As Integer, sSelectDrive As String
Dim sTemp2 As String, sTemp As String, iSlashSpot As Integer

Left = (Screen.Width - Width) / 2
Top = (Screen.Height - Height) / 2
ReDim sMainDrives(0)
sSelectDrive = ListDrives(Me, frmDirTree.tvwDirTree, frmDirTree.imgDirTree, frmDirTree.picIcon)

'**************
Exit Sub
'This will select the first fixed disk
ReDim sMainDrives(0)
For k = 1 To tvwDirTree.Nodes.Count
    If tvwDirTree.Nodes(k).Text = sSelectDrive Then
        tvwDirTree.Nodes(k).Selected = True
        ListDirs frmDirTree.tvwDirTree, tvwDirTree.Nodes(k).Key
        sMainDrives(0) = tvwDirTree.Nodes(k).Key
        lblPath = vbCrLf & tvwDirTree.Nodes(k).Key & "\"
        Exit For
    End If
Next

'******************
Exit Sub
'This selects the current drive or any valid drive supplied
sSelectDrive = CurDir$
sTemp = sSelectDrive
Do
    iSlashSpot = InStr(sSelectDrive, "\")
    If iSlashSpot > 1 Then
        'get a drive letter and see which type of drive it is
        sTemp2 = sTemp2 & StrConv(Left$(sSelectDrive, iSlashSpot), vbProperCase)
        ListDirs frmDirTree.tvwDirTree, sTemp2
        k = UBound(sMainDrives) + 1
        ReDim Preserve sMainDrives(k)
        sMainDrives(k) = Left$(sTemp2, Len(sTemp2) - 1)
        'Get the next drive letter
        sSelectDrive = Mid$(sSelectDrive, iSlashSpot + 1)
    End If
Loop Until iSlashSpot <= 1

For k = 1 To tvwDirTree.Nodes.Count
    If UCase$(tvwDirTree.Nodes(k).Key) = UCase$(sTemp) Then
        tvwDirTree.Nodes(k).EnsureVisible
        tvwDirTree.Nodes(k).Selected = True
        lblPath = vbCrLf & tvwDirTree.Nodes(k).Key & "\"
        Exit For
    End If
Next


End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Set frmDirTree = Nothing
End Sub


Private Sub tvwDirTree_Collapse(ByVal Node As Node)
tvwDirTree_NodeClick Node
End Sub

Private Sub tvwDirTree_Expand(ByVal Node As Node)
Dim lRet As Long, k As Integer
On Error Resume Next
If Node.Key = "root" Or Node.Key = "desk" Then
    Exit Sub
End If

'check to see if the drive or dir has been read
For k = 0 To UBound(sMainDrives)
    If sMainDrives(k) = Node.Key Then
        'We've already listed the sub dirs once so get out
        Exit Sub
    End If
Next
'check to see if there are sub dirs. If not get out
If Node.Children = 0 Then Exit Sub

Node.Sorted = True

Screen.MousePointer = 13
'true off the redraw for the tree view
lRet = SendMessage(tvwDirTree.hwnd, WM_SETREDRAW, False, 0&)
'list all of the sub directories
ListDirs frmDirTree.tvwDirTree, (Node.Key)
'redraw the control
lRet = SendMessage(tvwDirTree.hwnd, WM_SETREDRAW, True, 0&)

'iAdd the dir so we don't read it twice
lRet = UBound(sMainDrives)
ReDim Preserve sMainDrives(lRet + 1)
sMainDrives(lRet + 1) = Node.Key
Screen.MousePointer = 0

End Sub

Private Sub tvwDirTree_NodeClick(ByVal Node As Node)

'if it is a floppy then recheck
If Node.Key = "A:" Or Node.Key = "B:" Then
    Screen.MousePointer = 13
    ListDirs frmDirTree.tvwDirTree, (Node.Key)
    Screen.MousePointer = 0
End If

If Node.Key = "root" Or Node.Key = "desk" Then
    lblPath = ""
    Exit Sub
End If

If TextWidth(Node.Key) > lblPath.Width Then
    lblPath = Node.Key
Else
    ' if not put it at the bottom
    lblPath = vbCrLf & Node.Key
End If
End Sub




